;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram (VT-DOS -hoz mdostva)
;
;-----------------------------------------------------------------
;




;
;	Fjlkezel alaphelyzetbe lltsa
;	in:  -
;	out: -
;
fk_init:ld	hl,pathbuff1		; #1 panel kivlasztsa
	ld	(path_ptr),hl		; HL egyben az #1-es panel tvonalpufferre mutat
	xor	a
	ld	(hl),a			; pufferek els bjtjnak trlse (res pufferek)
	ld	(pathbuff2),a
	ld	(fnamebuff),a
	ld	a,SORT_KIT		; alap rendezsi szempont belltsa
	ld	(sorttype),a
	ret


;
;	Fjlkezel belpsi pontja
;	in:   A - megjelensi md sorszma (0 vagy 1)
;	out:  A - hibakd: 255 -> ESC-et nyomtak
;	     IY - megrzdik
;
fk_open:push	iy
	ld	iy,fv_vmod0		; IY  a 0. grafikus megjelents paramtereire mutat
	dec	a
	jr	nz,fk_opn
	ld	iy,fv_vmod1		; IY az 1. grafikus megjelents paramtereire mutat
fk_opn:	ld	a,000h			; A reg.= aktulis vide zemmd (most fixen 2-szn md)
	ld	(origvmode),a		; zemmd mentse
;
	ld	hl,fk_err_handler	; HL= belltand cm
	call	fk_set_errhand		; hibakezel rutin belltsa
;
	ld	a,01Fh			; parancskd: diszk-ROM verziszm beolvassa
	call	fk_fish			; FISH funkci hvsa
	bit	0,b			; f verziszm 0. bitjnek vizsglata
	ld	a,0F0h			; memrialapozs: U0,U1,U2,EXT/IOMEM
	jr	nz,fk_opn0		; ugrs, ha interfsz krtya
	ld	a,030h			; memrialapozs: U0,U1,U2,CART
fk_opn0:ld	(diskpg),a		; diszk RAM memrialapozsi rtknek mentse
;
	ld	hl,(path_ptr)
	ld	a,(hl)
	or	a
	jp	nz,fk_op0		; ugrs, ha van aktv tvonal (pl. visszatlts utn)
	ld	b,000h			; B= vltoz rtknek olvassa lesz
	ld	e,021h			; E= DEF_UNIT vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz beolvassa
	call	fk_fish			; FISH funkci hvsa
	ld	b,d			; B= DEF_UNIT vltoz
	push	bc			; vltoz a verembe is
	ld	a,003h			; parancskd: aktulis knyvtr beolvassa
	call	fk_fish			; FISH funkci hvsa
	pop	bc
	or	a
	jr	nz,fk_op0		; ugrs, ha hiba trtnt (pl. nincs krtya behelyezve)
	di
	ld	a,(diskpg)		; A reg.= diszk RAM memrialapozsi rtke
	out	(002h),a		; lapozs belltsa
	call	pathcp0			; HL mutatta tvonalstring tmsolsa az U0 RAM-ba
	ld	a,(0003Bh)		; lapozs vissza
	out	(002h),a
	ei
	ld	a,b			; A= DEF_UNIT  vltoz
	add	a,040h			; meghajt betjelnek meghatrozsa
	ld	de,(path_ptr)
	ld	(de),a			; meghajt betjele
	inc	de
	ld	a,':'
	ld	(de),a
	inc	de
	ld	a,92			; '\'
	ld	(de),a
	inc	de
	ld	hl,strbuff		; tvonalstring tmsolsa az U0 RAM-bl a sajt RAM-ba
	call	pathcp1			; msols a HL mutatta cmtl a lezr nullig
;
fk_op0:	ld	a,002h
	ld	(retry_cnt),a		; jraprblkozsok szma= 2
fk_op0a:call	fk_dir			; az adott knyvtr tartalmnak beolvassa
	call	fk_err			; hiba kezelse
	jr	c,fk_op0a		; ha ellenrzs utn CY=1 -> jra prblkozik
	jp	nz,fk_end		; ha nem kezelhet a hiba, visszatr
	ld	a,00Eh			; parancskd: szektorpufferek trlse (krtyacsere esetre)
	ld	bc,0FFFFh		; minden meghajtra vonatkozik a parancs
	call	fk_fish			; FISH funkci hvsa
	xor	a
	ld	(nselect),a		; kivlasztott fjlok szmnak nullzsa
	ld	h,a
	ld	l,a
	ld	(selcap),hl		; kivlasztott mret nullzsa
	ld	(selcap+2),hl
fk_opc:	call	fk_bord			; httr s keret rajzolsa
	call	fk_sort			; fjlnevek rendezse
	call	fk_dspl			; knyvtrtartalom megjelentse
	call	fk_suml			; sszest sor kirsa
	ld	a,IY_FSTLN		; az els sor inverz megjelentse
	ld	(akt_ln),a
	call	fk_linv
	ld	a,0
	ld	(xaktbj),a		; index-vltoz alaphelyzetbe
	call	fk_clnkey		; billentyzet-puffer kitakartsa
fk_op1:	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	cp	0F8h			; bal oldali joystick rtkeinek konvertlsa
	jr	nz,fk_op2c		; ugrs, ha nem bal-tz
	ld	a,0E8h
fk_op2c:cp	0FEh
	jr	nz,fk_op2d		; ugrs, ha nem bal-fl
	ld	a,01Eh
fk_op2d:cp	0FFh
	jr	nz,fk_op2		; ugrs, ha nem bal-le
	ld	a,01Fh
fk_op2:	call	fk_nagy			; kisbetk nagybetv konvertlsa
	cp	01Fh			; JOY le
	jr	nz,fk_op4
fk_op2b:ld	a,(nbj)			; bejegyzsek szma
	ld	b,a
	ld	a,(xaktbj)
	inc	a
	cp	b
	jr	z,fk_op1		; ugrs, ha ez volt az utols tallt bejegyzs
	ld	(xaktbj),a
	ld	a,(akt_ln)
	call	fk_linv			; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	inc	a
	ld	(akt_ln),a
	dec	a
	cp	IY_LSTLN		; utols sorban volt korbban?
	jr	nz,fk_op3
	ld	(akt_ln),a		; ha igen, helybenmarad
	call	fk_scup			; s scroll felfel
	ld	c,IY_LSTLN		; Y= utols sor
fk_op3a:ld	b,IY_NAMECL		; X=1
	push	bc			; (itt scrollozskor trlni kell a sort a kijellsek miatt, kivve ha az a szveggel azonos hosszsg)
	ld	a,c
	ld	c,IY_SELSTART
	ld	e,IY_SELCH
	ld	d,000h
	call	fk_cln0			; sor trlse az esetleges kijells miatt
	pop	bc
	ld	a,(xaktbj)
	call	fk_fadr			; fjlnvcm kiolvassa
	call	fk_fnir			; formzott fjlnv kirsa
fk_op3:	ld	a,(akt_ln)
	call	fk_linv
	jp	fk_op1
fk_op4:	cp	01Eh			; JOY fel
	jr	nz,fk_op6
	ld	a,(xaktbj)
	dec	a
	cp	0FFh
	jr	z,fk_op1		; ugrs, ha ez volt a legels bejegyzs
	ld	(xaktbj),a
	ld	a,(akt_ln)
	call	fk_linv			; rgi sor vissza-invertlsa
	ld	a,(akt_ln)
	dec	a
	ld	(akt_ln),a
	cp	IY_FSTLN		; els eltti sor?
	jr	nc,fk_op3
	inc	a
	ld	(akt_ln),a		; ha igen, helybenmarad
	call	fk_scdw			; s scroll lefel
	ld	c,IY_FSTLN		; Y= els sor
	jp	fk_op3a
fk_op6:	cp	00Dh			; RETURN
	jr	z,fk_op7
	cp	0E8h			; JOY tz
	jr	nz,fk_op8
fk_op7:	call	fk_slct
	jp	c,fk_op12b		; ugrs, ha knyvtrvlts volt
	jp	fk_op1			; ugrs, ha nem trtnt fjl-kivlaszts
fk_op8:	ld	b,001h			; rendezsi szempont vltsa
	cp	'N'
	jr	z,fk_op9		; ugrs, ha nv szerint
	inc	b
	cp	'K'
	jr	z,fk_op9		; ugrs, ha kiterjeszts szerint
	inc	b
	cp	'M'
	jr	z,fk_op9		; ugrs, ha mret szerint
	inc	b
	cp	'D'
	jr	nz,fk_op11		; ugrs, ha nem dtum szerint
fk_op9:	ld	a,(sorttype)		; korbbi rendezsi md A reg.-be
	and	07Fh
	cp	b
	ld	a,b
	jr	nz,fk_op10		; ugrs, ha a rendezsi szempont vltozott
	ld	a,(sorttype)		; korbbi rendezsi md ismt A reg.-be
	xor	080h			; rendezsi irny bit invertlsa
fk_op10:ld	(sorttype),a
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
fk_op11:cp	'1'			; #1 panel kivlasztsa
	ld	de,pathbuff1
	jr	z,fk_op12
	cp	'2'			; #2 panel kivlasztsa
	ld	de,pathbuff2
	jr	nz,fk_op13
fk_op12:ld	hl,(path_ptr)
	or	a
	sbc	hl,de
	jp	z,fk_op1		; ugrs, ha nem vltozott az aktulis panel
	ld	(path_ptr),de		; egybknt az j tvonalpuffer cmnek belltsa
fk_op12b:
	jp	fk_op0			; ugrs az j knyvtr beolvassra
fk_op13:cp	'0'			; a kt panel felcserlse
	jr	nz,fk_op15
	ld	b,66			; a kt tvonal string felcserlse
	ld	de,pathbuff1
	ld	hl,pathbuff2
fk_op13b:
	ld	c,(hl)
	ld	a,(de)
	ld	(hl),a
	ld	a,c
	ld	(de),a
	inc	de
	inc	hl
	djnz	fk_op13b
	ld	de,pathbuff1		; aktulis panel tvltsa, hogy az eredetileg megjelentett knyvtr ltszdjon
	ld	hl,(path_ptr)
	sbc	hl,de
	jr	nz,fk_op14
	ld	de,pathbuff2
fk_op14:ld	(path_ptr),de
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
;
fk_op15:cp	0ECh			; INS
	jr	nz,fk_op16
	ld	a,(xaktbj)
	call	fk_fadr			; fjlnvcm kiolvassa
	ld	de,11
	add	hl,de
	ld	a,(hl)
	xor	080h			; 7. bit invertlsa 
	ld	(hl),a
	bit	4,a			; knyvtr-bit ellenrzse
	jr	nz,fk_op6d		; ugrs, ha alknyvtr
	ld	e,5
	add	hl,de			; HL a fjlmretre mutat
	ld	e,(hl)			; fjlmret BC:DE-be
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(selcap)		; HL-be a kivlasztott fjlok sszmretnek als szava
	and	080h
	jr	z,fk_op6b		; ugrs, ha cskkent a kivlasztott fjlok szma
	add	hl,de			; sszmret nvelse a fjl mretvel
	ld	(selcap),hl
	ld	hl,(selcap+2)
	adc	hl,bc
	jr	fk_op6c
fk_op6b:sbc	hl,de			; sszmret cskkentse a fjl mretvel
	ld	(selcap),hl
	ld	hl,(selcap+2)
	sbc	hl,bc
fk_op6c:ld	(selcap+2),hl
fk_op6d:and	080h
	rlca				; legfels bit CY-be is
	dec	a			; ez nem lltja CY-t
	ld	b,a
	ld	a,(nselect)
	adc	a,b
	ld	(nselect),a
	ld	a,(akt_ln)
	ld	c,IY_SELSTART		; C= invertls kezdete
	ld	d,IY_SELCH		; D= az els 45 karakter a sorban
	ld	e,00Ah			; E= 10 TV sor
	call	fk_lin4			; sor invertlsa a kpernyn		
;	call	fk_clsm			; als sor trlse  !!! sszest sor kirsa tl lass, ezrt egyelre kikommentezve
;	call	fk_suml			; sszest sor frisstse  !!! ld. mg "fk_suml" rutinnl is
	jp	fk_op2b			; ugrs a kijell sor eggyel lejjebb lptetsre
fk_op16:cp	'3'
	jr	nz,fk_op17		; ugrs, ha nem '3'
;
	CALL_FKTVIEW			; fjl megnzse
;
	jp	nc,fk_opc		; ha megjelentette, ugrs a kperny jbli kirajzolsra
	jp	fk_op1			; egybknt, csak vr a kvetkez billentyre
fk_op17:cp	0EFh			; SHIFT + DEL -> trls
	jr	z,fk_op18
	cp	'4'
	jr	c,fk_op19		; ugrs, ha '4'-nl kisebb
	cp	'7'+1
	jr	nc,fk_op19		; ugrs, ha '7'-nl nagyobb
fk_op18:
;
	CALL_FKFUNC			; fjlkezelsi funkci vgrehajtsa
;
	call	fk_erff			; hiba kirsa
	jp	nc,fk_op12b		; ha frissteni kell, ugrs a knyvtr ismtelt beolvassra
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
;
fk_op19:cp	'S'
	jr	nz,fk_op20		; ugrs, ha nem 'S'
	call	fk_pal0			; teljesen fekete paletta belltsa
;
	CALL_FKSUGO			; sg megjelentse
;
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
;
fk_op20:cp	'F'
	jr	nz,fk_op21		; ugrs, ha nem 'F'
	call	fk_free			; szabad terlet szmtsa s kirsa
	or	a
	jp	nz,fk_op12b		; ha hiba trtnt, ugrs a knyvtr ismtelt beolvassra
	jp	fk_op1
fk_op21:cp	'G'
	jr	nz,fk_op22		; ugrs, ha nem 'G'
	ld	l,IY_NEXT_L
	ld	h,IY_NEXT_H
	push	hl
	pop	iy			; IY a kvetkez grafikus megjelents paramtereire mutat
	jp	fk_opc			; ugrs a kperny jbli kirajzolsra
fk_op22:cp	'V'
	jr	nz,fk_op23		; ugrs, ha nem 'V'
	call	fk_basic		; vlts BASIC-be
	jp	fk_opc			; ha mgsem, akkor ugrs a kperny jbli kirajzolsra
fk_op23:cp	27			; ESC
	jp	nz,fk_op1
	ld	a,0FFh			; A=0xFF ->CANCEL
fk_end:	push	af			; visszatrsi hibakd a verembe
	call	fk_pal0			; teljesen fekete paletta belltsa
	ld	a,(origvmode)		; belpskori videzemmd visszalltsa
	ld	c,a			; GRAPHICS x, kperny trlse
	call	ed_vidmode
	call	fk_setpath		; aktulis tvonal belltsa
	pop	af
	pop	iy	
	ret


;
;	Aktulis tvonal belltsa a kivlasztott fjlnak megfelelen
;	in:  -
;	out: -
;
fk_setpath:
	call	pathcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	a,(strbuff)
	or	a
	jr	nz,fk_set0		; ugrs, ha nem a meghajt-listban van
	ld	(strbuff+1),a
	ld	a,92			; '\'
	ld	(strbuff),a		; gykrknyvtr belltsa
	ld	a,(xaktbj)
	call	fk_fadr			; fjlnvcm kiolvassa
	ld	a,(hl)			; A reg.-be a kurzorpozcinak megfelel meghajt betjele
	cp	'<'
	jr	nz,fk_set0		; ugrs, ha van zemksz meghajt
	ld	a,'A'
fk_set0:sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	d,a			; D= meghajt sorszm

;
;	Aktulis tvonal belltsa a stringbufferbl
;	in:  D - meghajt sorszma (A->1 B->2 ..)
;	out: -
;
fk_setpath_sbuff:
	ld	b,0FFh			; B= vltoz rtknek rsa lesz
	ld	e,021h			; E= DEF_UNIT vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz belltsa
	call	fk_fish			; FISH funkci hvsa
	ld	hl,strbuff		; HL= tvonalnv kezdete
	ld	a,002h			; A = FISH funkci: knyvtr-vltoztats
	call	fk_fish			; FISH funkci hvsa
	ld	hl,00000h		; HL= belltand cm
	call	fk_set_errhand		; hibakezel rutin nullzsa
	ret


;
;	A fjlkezel kls hibakezelje
;
fk_err_handler:
	ld	a,001h
	ret


;
;
;	A fjlkezel kls hibakezeljnek belltsa
;	in:  HL - belltand hibakazel rutin cme (0000h - nincs hibakezel rutin)
;	out:    -
;
fk_set_errhand:
	ex	de,hl			; rutincm DE-be
	ld	c,083h			; C= funkcikd: diszk-hiba szubrutin definilsa
	call	0005h			; VT-DOS hvsa
	ret


;
;	Hibakezels knyvtrbeolvass utn
;	in:   A - hibakd
;	out: CY - 1: a lemezes hiba utn jra kell prblkozni
;	     ZF - 1: nem trtnt hiba
;
fk_err:	or	a			; CY=0
	ret	z			; visszatrs, ha nem volt hiba
	cp	0A1h			; .NOFIL - utols tallat utn
	jr	nz,fk_er1		; ugrs, ha nem ez a hiba volt
	ld	a,(nbj)
	or	a
	ld	a,0A1h
	jp	z,fk_er3
	xor	a			; nincs hiba, ha tallt legalbb 1 fjlt (a gykrbe is bekerl a "..") (CY=0)
	ret
fk_er1:	cp	0A0h			; .NODIR - lemezcsere trtnhetett vagy kitrltk az adott knyvtrat
	jr	nz,fk_er2		; ugrs, ha nem ez a hiba volt
	call	fk_dout			; aktulis tvonal visszalptetse, legfeljebb a meghajt-listig
	scf				; jra kell prblkozni
	ret
;
fk_er2:	cp	0ADh			; .ABORT - nincs lemez/meghajt, vagy rossz
	jr	nz,fk_er3
	ld	a,(retry_cnt)
	dec	a
	ld	(retry_cnt),a
	scf				; jra kell prblkozni
	ret	nz			; ha lejrt az jraprblkozsok szma: hibakd= 00h
fk_er3:	ld	hl,(path_ptr)		; aktulis tvonal belltsa a meghajt-listra
	ld	(hl),000h
	ld	b,00h			; kirja az A reg.-ben adott hibt, s hibajelzs nlkl tr majd vissza
	or	a			; ZF= 0
	call	nz,fk_er4a		; .ABORT esetn nem r ki semmit
	scf				; jra kell prblkozni -> a meghajt-listt fogja beolvasni
	ret


;
;	Hibakezels fjlmveletek utn
;	in:   A - hibakd
;	out: CY - CY=0 -> jra be kell olvasni a knyvtrat
;	          CY=1 -> elg csak a kpernyt frissteni
;
fk_erff:or	a
	ret	z			; visszatrs, ha nem volt hiba (CY=0)
	cp	092h			; .CTRLC - megszaktottk a parancs vgrehajtst (CLI hibakd)
	scf
	ret	z			; visszatrs, ha ESC volt (CY=1 -> csak frissteni kell a kpernyt)
	cp	089h			; .IPSTR - hibs cl vagy forrs tvonal (CLI hibakd)
	jp	nz,fk_erf0		; ugrs ha nem ez a hiba volt
	ld	hl,erptext		; hibs cl vagy forrs tvonal (nincs hibakd, ZF=1)
	call	fk_er4
	scf				; CY=1
	ret
;
fk_erf0:ld	hl,fuhiba		; lemezes/MOPS hibk kirsa csak hibakddal
	push	af
	call	fk_prn0			; kirs az aktulis karakterpozciba
	pop	af
	ld	l,a
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'
	call	fk_chnk			; bevezet '0'-k levgsa s a szm kirsa
	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	xor	a			; CY=0
	ret


;
;	Hibazenet kirsa
;	in:   A - tnyleges hibakd
;	      B - visszatrskor visszaadand hibakd
;	     HL - hibazenet stringre mutat
;	     ZF - ZF=0 - a hibakdot is kirja az zenet utn
;	out:  A - belpskor B-ben adott hibakd
;
fk_er4a:ld	hl,errtext		; nem dekdolt hiba, kirja a kdjt (ZF=0)
fk_er4:	push	bc
	push	af
	call	fk_msg
	pop	af
	jr	z,fk_er5		; ugrs, ha nem kell a hibakdot kirni
	ld	l,a
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'
	call	fk_chnk			; bevezet '0'-k levgsa s a szm kirsa
fk_er5:	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa	
	call	fk_clsm			; als sor trlse
	call	fk_suml			; sszest sor kirsa
	pop	af
	or	a			; CY= 0, ZF pedig B reg. belpsi rtktl fgg "fk_er4"-nl
	ret

;
;	Billentyzet-puffer kitakartsa (pergsmentests knyvtrvlts utn)
;	in:     -
;	out:  A - hibakd
;
fk_clnkey:
	ld	e,0FFh			; input krse
	ld	c,006h			; kzvetlen konzol I/O
	call	0005h			; VT-DOS hvsa
	or	a
	jr	nz,fk_clnkey		; ismtls amg van karakter
	ret

;
;	RETURN/JOY tz ellenrzse
;	in:   -
;	out: CY - CY=1 knyvtrvlts trtnt, az j knyvtr tartalmt be kell olvasni
;	     ZF - ZF=1 fjl-kivlaszts trtnt
;
fk_slct:ld	a,(xaktbj)
	call	fk_fadr			; aktulis bejegyzs cme HL-be
	ld	de,11
	add	hl,de
	ld	a,(hl)
	and	10h			; attributum ellenrzse
	jr	nz,slct3		; ugrs, ha nem fjl van kivlasztva
	dec	hl
	dec	hl
	dec	hl			; HL a fjl kiterjesztsre mutat
	call	fk_exec			; program elindtsa, ha lehetsges
	or	a			; CY= 0
	ret	z			; visszatrs, ha nem volt hiba (ZF= 1)
	ld	hl,erctext
	cp	08Ch			; hibakd: .NORAM - nem elg a memria
	jr	z,slct0
	ld	hl,errtext		; nem dekdolt hiba, kirja a kdjt (ZF=0)
slct0:	ld	b,a			; B= hibakd a visszatrshez
	jp	fk_er4			; ugrs a hiba kirsra
;
slct3:	ld	hl,(path_ptr)		; knyvtrt vlasztottak
	xor	a
	cp	(hl)
	jr	nz,slct4		; ugrs, ha nem a meghajt-listban van
	ex	de,hl			; ha az tvonal els karaktere 0 volt, akkor meghajt root-t llt be
	ld	hl,(akt_bj)
	ld	a,'<'			; A reg.= 'nincs egy meghajt'-t jelz karakter
	cp	(hl)
	jr	z,slct7			; ha korbban nem tallt meghajtt, akkor csak a frisstst jelzi
	ldi				; meghajt betjele
	ldi				; kettspont
	ld	a,92			; '\'
	ld	(de),a
	inc	de
	xor	a
	ld	(de),a			; lezr nulla
	jr	slct7
;
slct4:	ld	hl,(akt_bj)		; a kivlasztott alknyvtrnv elemzse
	ld	a,(hl)
	cp	'.'			; visszalps egy knyvtrral?
	jr	nz,slct6		; ugrs, ha biztosan nem
	inc	hl
	ld	a,(hl)
	cp	' '			; ez az aktulis knyvtr jelzse volt?
	jr	nz,slct5
	or	a			; A=32, ZF=0  (NZ), CY= 0
	ret
;
slct5:	cp	'.'
	dec	hl
	jr	nz,slct6		; ugrs, ha nem ".."
	call	fk_dout			; visszalps egy knyvtrral
	jr	slct7
;
slct6:	call	fk_dent			; tvonal bvtse az alknyvtr nevvel
slct7:	scf				; CY= 1	
	ret

;
;	Belps egy alknyvtrba (az aktulis tvonalnv bvtse)
;	in:  HL - az alknyvtr 8+3-as nevre mutat
;	     DE - bvtend tvonal cme (csak fk_den0-nl belpve)
;	out: CY - CY=1 -> nem lpett be
;
fk_dent:ld	de,(path_ptr)		; az aktulis tvonalat bvti
fk_den0:ex	de,hl
	ld	bc,0100h		; max. 256 karakter tvizsglsa
	xor	a
	cpir				; tvonal-string vgnek megkeresse
	sub	c			; A reg.= sszes karakter a stringben lezr 0-val egytt
	cp	62
	ccf
	ret	c			; visszatrs, ha 61-nl hosszabb a string
	push	hl			; string vge a verembe
	push	af			; stringhossz a verembe
	ex	de,hl
	call	fk_name			; knyvtrnv msolsa a fjlnv pufferbe
	ld	hl,fnamebuff		; fjlnv puffer cme
	ex	de,hl
	sbc	hl,de			; HL= fjlnv hossza
	pop	af			; A reg.= tvonalstring aktulis hossza
	add	a,l			; A reg.= bvts utn vrhat hossz
	pop	hl
	cp	65
	ccf
	ret	c			; visszatrs, ha 64-nl hosszabb lenne a string
	dec	hl			; HL a zrkarakterre mutat
	dec	hl			; utols hasznos karakter
	ld	a,92			; '\'
	cp	(hl)
	jr	z,fk_den1		; ugrs, ha a gykrknyvtrban van (pl. A:\)
	inc	hl
	ld	(hl),a
fk_den1:inc	hl
	ld	de,fnamebuff		; fjlnv puffer cme
	ex	de,hl
	ld	bc,0C00h		; max_hossz= 12  spec.kar= 0
	call	fk_scpy			; fjlnv msolsa az tvonalstringbe
	xor	a
	ld	(de),a			; zr nulla bersa, CY=0
	ret

;
;	Visszalps egy knyvtrral (az aktulis tvonalnv visszavgsa az utols '\' jelig)
;	in:  HL - visszalptetend tvonal cme (csak fk_dou0-nl belpve)
;	out:  B - a lezr nulla helyn llt karakter
;	     HL - a visszavgott nv lezr nulljra mutat
;	     ZF - ZF=1 -> a gykrknyvtrban van, B tartalmazza az elz knyvtr kezdbetjt
;
fk_dout:ld	hl,(path_ptr)
fk_dou0:ld	a,(hl)
	or	a
	jr	z,fk_dou1		; ugrs, ha nincs tvonal
	ld	bc,0100h		; max. 256 karakter tvizsglsa
	xor	a
	cpir				; tvonal-string vgnek megkeresse
	dec	hl			; HL a zrkarakterre mutat
	dec	hl			; HL az utols hasznos karakterre mutat
	ld	a,92			; '\'
	cp	(hl)
	jr	nz,fk_dou2		; ugrs, ha nem a gykrben van
	ld	hl,(path_ptr)
	xor	a
	ld	(hl),a
fk_dou1:inc	a			; ZF= 0
	ret
;
fk_dou2:ld	bc,0100h		; max. 256 karakter tvizsglsa
	cpdr				; keress visszafelemenet a '\' jelre
	ld	a,':'
	cp	(hl)
	ld	a,000h			; lezr nulla elksztse
	jr	nz,fk_dou3		; ugrs, ha mg nem a gykrknyvtr
	inc	hl			; egybknt meghagyja a visszapert
fk_dou3:inc	hl
	ld	b,(hl)			; trlt karakter mentse B-be
	ld	(hl),a
	ret
	
;
;	tvonal msolsa a string bufferbe
;	in:  HL - msoland tvonalstring (pathcp0-nl belpve)
;	out:    -
;
pathcpy:ld	hl,(path_ptr)		; aktulis tvonalstring tmsolsa az U0 RAM-ba
pathcp0:ld	de,strbuff
pathcp1:ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	or	a
	jr	nz,pathcp1		; msols a lezr nullig
	ret


fuhiba	.text	"\r\n"
errtext	.text	"Hiba! \000"		; ltalnos hibazenet bevezet rsze
erctext	.text	"Nincs el\221g mem\223ria!\000"
eretext	.text	"Nem futtathat\223 \220llom\220ny!\000"
erptext	.text	"Hat\220rozatlan \226tvonal!\000"
;erptext.text	"A c\221l vagy forr\220s \226tvonala hat\220rozatlan!\000"
;
ldtext	.text	"Program bet\224lt\221se...\000"



;
;-----------------------------------------------------
;	Fjlnv-lista elksztse (adott knyvtr beolvassa)
;-----------------------------------------------------
;

;
;	FISH meghvsa
;
;	in:  A - FISH funkcikd
;	    BC,DE,HL,IX - paramterek
;	out: A - hibakd
;	    BC,DE,HL,IX - FISH funkci kimeneti paramterei
;
fk_fish:call	0008h			; FISH funkci vgrehajtsa VT-DOS alatt
	ret


;
; 	Hasznlatlan FCB kitltse
;	in:  DE - kitltend FCB elejre mutat
;	     HL - berand 8+3-as fjlnv
;	out: -
;
fk_fcb:	push	hl
	ld	h,d			; HL is az FCB elejre mutat
	ld	l,e
	xor	a
	ld	b,48			; 48 bjt trlse
fk_fcb0:ld	(de),a
	inc	de
	djnz	fk_fcb0
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	ld	de,0006
	add	hl,de
	ld	(hl),0			; keressi attributum (nem keres ktet azonostt)
	inc	hl
	ld	(hl),0			; 0=aktulis meghajt
	inc	hl
	pop	de			; DE= 8+3 bjtos fjlnv
	ex	de,hl
	ld	bc,11			; 8+3 bjtos fjlnv tmsolsa
	ldir				; a tbbi vltoz nulla
	ret

;	
;	Els illeszked knyvtrbejegyzs keresse (tvonal strbuff-ban)
;	in:  HL - 8+3 (11 karakteres) fjlnvre mutat
;	out:  A - hibakd 
;
fk_frst:ld	de,FCB_1		; FCB1 kitltse hasznlatlan FCB-knt a megadott nvvel
	call	fk_fcb
	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	ld	hl,strbuff		; HL= tvonalnv kezdete
	ld	a,004h			; A = FISH funkci: els keresse
	call	fk_fish			; FISH funkci hvsa
	ret

;	
;	Egy knyvtr fjlneveinek beolvassa
;	in: -
;	out:  A - hibakd
;
fk_dir:	ld	hl,0000h		; fjlok sszestett mretnek nullzsa
	ld	(dircap),hl
	ld	(dircap+2),hl
	xor	a			; tallt fjlok szmnak nullzsa
	ld	(nfiles),a
	ld	hl,(path_ptr)
	cp	(hl)
	jp	z,fk_root		; ha nincs tvonal megadva, akkor a meghajtk listzsa
;
	inc	hl
	inc	hl
	inc	hl
	cp	(hl)			; ha pl. "A:\0" az tvonalnv
	ld	hl,nevtbl		; tallt 20 bjtos nvbejegyzsek kezdete
	jr	nz,fk_d0		; ugrs, ha nincs lezr nulla
	ld	a,'.'			; egy "elz knyvtr" bejegyzs ltrehozsa
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	de,meghtxt+2
	ld	bc,18
	ex	de,hl
	ldir
	ex	de,hl			; HL=kvetkez bejegyzs cme
	ld	a,01			; egy bejegyzs mr van
fk_d0:	ld	(akt_bj),hl
	ld	(nbj),a			; tallati szmll kezd rtke
	call	pathcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	hl,fn_all		; HL a *.*-nak megfelel krdjelekre mutat
	call	fk_frst			; els keresse
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
;
fk_d1:	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= keressi FCB (az els keressbl)
	ld	a,005h			; A = FISH funkci: kvetkez keresse
	call	fk_fish			; FISH funkci hvsa
	or	a			; volt hiba?
	ret	nz			; egyelre nem kezeli, de valsznleg nincs tbb fjl
	ld	hl,FCB_0		; FCB_0 a tallt meghatrozott FCB
	call	fk_mnev			; 20 bjtos nvbejegyzs tmsolsa
	jr	nz,fk_d1		; ismtls az sszes bejegyzs megkeressig
	ret				; vagy amg el nem ri a maximlis fjlnv szmot

;
;	Meghajt azonostk listzsa
;	(az els hibs/res meghajt utn nem listz tovbb)
;
fk_root:
	ld	hl,nevtbl		; tallt 20 bjtos nvbejegyzsek kezdete
	ld	(akt_bj),hl
	ld	b,001h			; els meghajtval kezd
root0:	push	bc
	ld	a,003h			; A = FISH funkci: aktulis knyvtr beolvassa
	call	fk_fish			; FISH funkci hvsa
	pop	bc
	or	a
	jr	nz,root1		; ugrs, ha hiba volt
	ld	a,b
	add	a,040h
	ld	de,(akt_bj)		; ide menti a nevet
	ld	(de),a
	ld	a,b
	inc	de
	ld	bc,19			; BC= htralv bjtok a 20-bjtos bejegyzsbl
	ld	hl,meghtxt+1
	ldir				; tbbi adat konstans
	ld	(akt_bj),de		; nvmutat mentse, mr a kv. bejegyzsre mutat
	ld	b,a
	inc	b
	jp	root0			; ugrs a kvetkez meghajt ellenrzsre
root1:	dec	b
	call	z,root2			; korrekci, ha egy meghajtt sem tallt volna
	ld	a,b
	ld	(nbj),a			; tallt meghajtk szma
	xor	a			; ZF=1 - nincs hiba
	ret
;
root2:	ld	de,(akt_bj)		; ide menti a nevet
	ld	bc,3			; <A:> - szveg rsa
	ld	hl,meghtxt-1
	ldir
	ld	a,'>'
	ld	(de),a
	inc	de
	inc	hl
	inc	hl
	ld	c,16
	ldir
	ld	b,1
	ret	
;
fn_all	.db	"???????????"		; fjlnv minden fjlhoz (*.*)
	.db	'<'
meghtxt .db	"A:         "		; meghajtk listzshoz s ".." bejegyzshez a fknyvtrban
	.db	10h			; attributum: alknyvtr
	.dw	0000h			; id
	.dw	0000h			; dtum
	.db	0,0,0,0			; fjlhossz: 0

;
;-----------------------------------------------------
;	Fjlnv-lista kezelse
;-----------------------------------------------------
;

;
;-----------------------------------------------------
;	Fjlnv-lista kezelse: rendezs
;-----------------------------------------------------
;

;
;	Karakterlncok sszehasonltsa
;	in:   B - sszehasonltand hossz (fk_cmp1-nl belpve)
;	     DE - egyik string cme
;	     HL - msik string cme
;	out: ZF - a kt string megegyezik
;	     CY - 1: a DE mutatta string kisebb  0: a HL mutatta string kisebb
;
fk_cmp:	ld	b,003h
fk_cmp1:ld	a,(de)
	cp	(hl)
	ret	nz
	inc	hl
	inc	de
	djnz	fk_cmp1
	ret

;
;	Fjlbejegyzsek sszehasonltsa
;	in:  DE - egyik 20 bjtos bejegyzs cme
;	     HL - msik 20 bjtos bejegyzs cme
;	out: DE - megrzdik
;	     HL - megrzdik
;	     CY - 1: a DE mutatta kisebb  0: a HL mutatta kisebb
;
fk_cext:push	de
	push	hl
	ld	bc,11
	add	hl,bc
	ld	a,(hl)
	and	10h			; knyvtrbit maszkolsa
	ex	de,hl
	add	hl,bc
	ld	c,a
	ld	a,(hl)
	and	10h			; knyvtrbit maszkolsa
	cp	c
	ccf
	pop	hl
	pop	de
	ret	nz			; visszatrs, ha az egyik knyvtr a msik pedig fjl, a knyvtr a kisebb
	and	10h			; knyvtrbit ellenrzse
	jr	z,cext1			; ugrs, ha mindkett fjl
	ld	b,8			; 8 karakter sszehasonltsa lesz
cext0:	push	de
	push	hl
	call	fk_cmp1			; (knyvtr)nevek sszehasonltsa
	pop	hl
	pop	de
	ret
;
cext1:	ld	a,(sorttype)		; rendezsi szempont vizsglata
	and	07Fh
	ld	b,11			; nv szerinti rendezshez 11 karaktert kell sszehasonltani
	dec	a
	jp	z,cext2			; ugrs, ha nv alapjn kell rendezni
	dec	a
	jp	nz,cext5		; ugrs, ha nem kiterjeszts alapjn
	push	de
	push	hl
	ld	bc,8
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl			; HL s DE is a fjlnv kiterjesztsekre mutat
	call	fk_cmp			; kiterjesztsek sszehasonltsa
	pop	hl
	pop	de
	jr	nz,cext3		; visszatrs, ha nem egyenlek
	ld	b,8			; 8 karakter sszehasonltsa lesz
cext2:	push	de
	push	hl
	call	fk_cmp1			; fjlnevek sszehasonltsa
	pop	hl
	pop	de
cext3:	rr	c			; CY belptetse C reg. 7. bitjre
cext4:	ld	a,(sorttype)		; rendezsi irny vizsglata
	xor	c			; A reg. 7. bitjben CY invertltja, ha ellenkez irny rendezs van
	rl	a			; eredmnybit vissza CY-be
	ret
;
cext5:	push	de
	push	hl
	ld	bc,12
	dec	a
	jr	nz,cext6		; ugrs, ha dtum alapjn kell rendezni
	ld	c,16
cext6:	ex	de,hl
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ld	a,(de)			; A reg.= DE ltal mutatott dtum/mret als bjtja
	sub	(hl)			; HL mutatta dtum/mret als bjtjnak kivonsa
	ld	c,a
	inc	de
	inc	hl
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	ld	b,a
	inc	de
	inc	hl
	push	bc			; als szavak klnbsge a verembe
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	ld	b,a
	inc	de
	inc	hl
	ld	a,(de)			; a tovbbi bjtok kivonsa egymsbl
	sbc	a,(hl)
	rr	c			; CY belptetse C reg. 7. bitjre
	or	b			; eredmny vizsglata, hogy nulla-e
	pop	hl			; HL= als szavak klnbsge
	or	h
	or	l
	pop	hl
	pop	de
	ld	b,11
	jp	z,cext0			; ha megegyeznek, akkor nv szerint nvekv sorrendben prblja rendezni
	jp	cext4			; ugrs a rendezsi irny ellenrzsre

;
;	Fjlnevek rendezse
;
fk_sort:ld	de,sortbuff		; DE= rendezpuffer cme
	ld	hl,nevtbl		; HL= tallt 20 bjtos nvbejegyzsek kezdete
	ld	a,(nbj)
	ld	b,a			; B= tallt bejegyzsek szma
	or	a
	ret	z			; visszatrs, ha nincs egy bejegyzs sem
sort3:	push	bc			; a rendezpuffer inicializlsa	
	ex	de,hl
	ld	(hl),e			; nv cme a rendez-pufferbe
	inc	hl
	ld	(hl),d
	inc	hl
	ex	de,hl
	ld	bc,20
	add	hl,bc			; HL a kvetkez fjlnvre mutat
	pop	bc
	djnz	sort3
	dec	a
	ret	z			; visszatrs, ha csak egy bejegyzs van (nincs mit rendezni)
	ld	c,a			; C= tallt bejegyzsek szma -1 (sszehasonltsok szma)
sort4:	ld	b,c
	ld	hl,sortbuff		; HL= els elem indexe
	ld	e,(hl)			; els elem cme DE-be
	inc	hl
	ld	d,(hl)
	dec	hl			; HL visszalltsa
sort5:	push	bc
	push	hl			; els elem indexe a verembe, cme DE-ben
	inc	hl
	inc	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a			; msodik elem cme HL-be
	call	fk_cext			; fjlnevek sszehasonltsa
	jr	nc,sort6		; a msodik elem a kisebb (HL), ez kerl az els helyre
	ex	de,hl			; msodik elem DE-be, els elem HL-be
sort6:	ld	c,l
	ld	b,h			; els elem BC-be
	pop	hl
	ld	(hl),c			; els elem bersa
	inc	hl
	ld	(hl),b
	inc	hl
	pop	bc
	djnz	sort5
	ld	(hl),e			; DE mutatta utols elem bersa
	inc	hl
	ld	(hl),d
	dec	c			; C= kvetkez ciklus hossza
	jr	nz,sort4
	ret

;
;	Rendez-buffer adott index elembl fjlnvcm kiolvassa
;	in:    A - index
;	out:  HL - 20-bjtos fjlnvbejegyzs kezdcme
;
fk_fadr:ld	de,sortbuff
	ld	l,a
	ld	h,000h
	add	hl,hl			; HL= 2* index
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	(akt_bj),hl		; cm trolsa a vltozban is
	ret

;
;	Tallt knyvtr-bejegyzsek kirsa a rendez buffer alapjn
;
fk_dspl:ld	b,IY_MAXLN		; B= maximlisan kirhat sorok szma
	ld	a,(nbj)
	cp	b			; a tallt bejegyzsek szma ennl kevesebb?
	jr	nc,dspl0		; ugrs, ha nem
	or	a
	ret	z			; vge, ha egy bejegyzs sincs
	ld	b,a			; egybknt az sszes bejegyzs kirsa
dspl0:	ld	c,IY_FSTLN		; C= az els sor szma
	ld	hl,sortbuff		; a rendez buffer 0. elemvel kezd
dspl1:	push	bc
	ld	e,(hl)			; fjlnvcm kiolvassa
	inc	hl
	ld	d,(hl)
	inc	hl
	push	hl
	ex	de,hl
	ld	b,IY_NAMECL		; X=nv oszlop  Y=akt. sor
	call	fk_fnir			; formzott fjlnv kirsa
	pop	hl
	pop	bc
	inc	c			; kvetkez sor
	djnz	dspl1			; ismtls az sszes sor vgig
	ret

;
;	Szveg msolsa a specilis karakterig vagy a lezr nullig
;	in:   B - maximlis hossz
;	      C - specilis karakter
;	     DE - cl
;	     HL - specilis karakterrel lezrt forrs
;	out: DE - utols karakter utn mutat
;	     HL - a specilis karakterre mutat (ha CY=0)
;	     CY - CY=0 elrte a specilis karaktert  CY=1 a maximlis hosszig vagy a nullig msolt
;
fk_scpy:ld	a,(hl)
	cp	c
	ret	z
	or	a
	scf
	ret	z
	ld	(de),a
	inc	de
	inc	hl
	djnz	fk_scpy
	ret

;
;	Fjlnv kirsi formtumnak elksztse (fjlnv.kit formtumban)
;	in:  DE - cl cme (fk_nam0 -nl belpve, egybknt a fjlnv pufferbe kerl)
;	     HL - 8+3-as fjlnv cme
;	out: DE - az elksztett string lezr nulla karakterre mutat
;
fk_name:ld	de,fnamebuff		; cl puffer cme
fk_nam0:ld	bc,0820h		; max_hossz=8 spec.kar=32
	push	hl
	call	fk_scpy			; fjlnv msolsa
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	bc,0008
	pop	hl
	add	hl,bc
	ld	bc,0320h		; max_hossz=3 spec.kar=32
	call	fk_scpy			; kiterjeszts msolsa
	ld	a,003h
	cp	b
	jr	nz,fk_nam1		; ugrs, ha legalbb egy karaktert msolt
	dec	de			; egybknt visszalps a '.' karakterre
fk_nam1:xor	a
	ld	(de),a
	ret


;
;-----------------------------------------------------
;	Bels formtum fjladatok kezelse
;-----------------------------------------------------
;

;
;	Egy 20 bjtos nvbejegyzs elksztse az adott FCB alapjn
;	in:  HL - FCB cme
;	out:  A - A=0 s ZF=1 -> elrte a max. trolhat bejegyzst
;	     DE - a ltrehozott struktrra mutat:
;	          0..10   fjlnv (8+3)
;	          11      attributum
;	          12,13   mdosts ideje
;	          14,15   mdosts dtuma
;	          16..19  fjl hossza bjtban
;
fk_mnev:ld	a,0FEh
	cp	(hl)
	ret	nz			; vissza, ha nem meghatrozott FCB
	ld	bc,8
	add	hl,bc			; HL a fjlnvre mutat az FCB-n bell
	ld	a,(hl)
	cp	'.'
	jr	nz,mnev0
	inc	hl
	ld	a,(hl)
	dec	hl
	cp	' '			; ez az aktulis knyvtr jelzse lehet?
	jr	nz,mnev0
	ld	d,h
	ld	e,l
	ld	bc,11
	add	hl,bc			; az attribtumot is ellenrizni kell
	ld	a,(hl)
	and	10h
	ret	nz			; visszatr, ha tnyleg az
	ex	de,hl
mnev0:	ld	de,(akt_bj)		; ide menti a nevet
	ld	bc,11			; 8+3 fjlnv
	ldir
	ld	a,(hl)			; A reg.= attribtum
	and	07Fh			; 7. bit trlse, ez a kivlasztottsgot fogja jellni
	ld	(de),a
	inc	de
	ld	bc,11
	add	hl,bc			; HL az id-adatokra mutat
	ld	bc,4			; 2 bjtos id + 2 bjtos dtum
	ldir
	inc	hl
	inc	hl
	ld	bc,4			; 4 bjtos fjlhossz
	ldir
	ld	(akt_bj),de		; nvmutat mentse, mr a kv. bejegyzsre mutat
	and	10h			; knyvtr-bit ellenrzse
	jr	nz,mnev1
	dec	hl			; ha nem alknyvtr, a fjlmret hozzadsa az eddigi sszeghez
	ld	b,(hl)
	dec	hl
	ld	c,(hl)
	dec	hl
	ld	d,(hl)
	dec	hl
	ld	e,(hl)
	ld	hl,(dircap)
	add	hl,de
	ld	(dircap),hl
	ld	hl,(dircap+2)
	adc	hl,bc
	ld	(dircap+2),hl
	ld	a,(nfiles)
	inc	a			; tallt fjlok szmnak nvelse
	ld	(nfiles),a
mnev1:	ld	a,(nbj)
	inc	a			; tallt bejegyzsek szmnak nvelse
	ld	(nbj),a
	sub	nbj_max			; ha ZF=1, elrte a max. trolhat bejegyzst
	ret

;
;	Kirand karakterek msolsa ellenrzssel
;	in:   B - msoland hossz
;	     DE - clterlet kezdete
;	     HL - msoland string kezdete
;	out:  B - 000h
;	     DE - az tmsolt cl string utnra mutat
;	     HL - az tmsolt forrs string utnra mutat
;
fk_ncpy:ld	a,(hl)
	inc	hl
	cp	020h
	jr	c,fk_ncp0
	cp	0E0h
	jr	c,fk_ncp1
fk_ncp0:ld	a,020h
fk_ncp1:ld	(de),a
	inc	de
	djnz	fk_ncpy
	ret

;
;	Egy knyvtrbejegyzs kirsi formtumnak elksztse
;	in:  HL - nv 20 bjtos bejegyzsnek kezdete
;	out:  A - attribtum bjt, a 7. bit a kivlasztottsgot jelzi
;            BC - formzott hossz
;
fk_fnev:ld	de,strbuff
	ld	b,008h			; fjlnv msolsa
	call	fk_ncpy
	ld	a,020h			; 2 db. SPACE a nv s kiterjeszts kz
	ld	(de),a
	inc	de
	ld	(de),a
	inc	de
	ld	b,003h			; kiterjeszts msolsa
	call	fk_ncpy
	push	hl			; az attributum cmnek mentse
	ld	a,020h
	ld	(de),a
	inc	de
	ld	a,(hl)			; attributum elemzse
	and	10h			; alknyvtr ?
	jr	z,fnev0
	ld	hl,dirtxt
	ld	bc,11
	ldir
	jr	fnev1	
fnev0:	ld	bc,8
	add	hl,bc			; HL a fjlhosszra mutat
	call	fk_ascc			; fjlhossz kirsa
	ld	a,32
	ld	(de),a
	inc	de
fnev1:	pop	hl
	ld	bc,25			; BC= szveg hossza (visszatrsi rtknek) (13+1+10+1)
	ld	a,IY_NCLMS		; megjelentend oszlopszm A reg.-be
	cp	003h
	ld	a,(hl)			; attribtum bjt A reg.-be visszatrshez
	ret	z			; visszatrs, ha csak 3 oszlop kell (4 szn md)
	push	hl
	ld	bc,4
	add	hl,bc			; HL a dtum bjtokra mutat
	call	fk_date
	ld	a,32
	ld	(de),a
	inc	de
	pop	hl
	inc	hl
	inc	hl			; HL az id bjtokra mutat
	call	fk_time
	ld	a,32
	ld	(de),a
	inc	de
	ld	c,(hl)			; C reg.= attributum
	ld	a,'r'
	bit	0,c			; READ ONLY bit
	jr	nz,fnatr
	ld	a,32
fnatr:	ld	(de),a
	inc	de
	ld	a,'a'
	bit	5,c			; ARCHIVE bit
	jr	nz,fnata
	ld	a,32
fnata:	ld	(de),a
	inc	de
	ld	a,'h'
	bit	1,c			; HIDDEN bit
	jr	nz,fnath
	ld	a,32
fnath:	ld	(de),a
	inc	de
	ld	a,'s'
	bit	2,c			; SYSTEM bit
	jr	nz,fnats
	ld	a,32
fnats:	ld	(de),a
	inc	de
	ld	a,c
	ld	bc,46			; BC= szveg hossza (visszatrsi rtknek) (13+1+10+1+10+1+5+1+4)
	ret

;
dirtxt	.text	"   <dir>   "		; alknyvtr nevnek kirshoz
;


;
;-----------------------------------------------------
;	Kperny-megjelent rutinok
;-----------------------------------------------------
;

;
;	Szveg kirsa adott karakteres pozciba az IOMEM terletrl
;	in:   B - X poz. (ha 0 az X pozci az aktulis marad)
;	      C - Y poz. (ha 0 az Y pozci az aktulis marad)
;	     HL - 0-val lezrt string
;	out: HL - a lezr nulla utni cm
;
fk_prn0:ld	bc,0000h		; vltozatlan pozci
fk_prnt:call	ed_cpos			; kurzor-pozcionls
	ld	de,strbuff		; szveg tmsolsa az U0 RAM-ba
fk_prn1:ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	or	a
	jr	nz,fk_prn1
	scf				; -1 a hosszbl a lezr nulla miatt
fk_prn2:push	hl			; lezr nulla utni cm a verembe
	ex	de,hl
	ld	de,strbuff
	sbc	hl,de			; stringhossz szmtsa
	jr	z,fk_prn3
	ld	b,h
	ld	c,l
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa
fk_prn3:pop	hl			; lezr nulla utni cm HL-be
	ret

;
;	Adott karakterek levgsa a szveg elejrl, majd kirs
;	in:  A - levgand karakter (pl. SPACE, '0')
;	    DE - szveg utols karaktere utni cmre mutat "strbuff"-ban
;
fk_chnk:ld	c,a
	ex	de,hl			; HL= string vge
	ld	(hl),000h		; lezr nulla elhelyezse
	ld	de,strbuff
chnk0:	ld	a,(de)
	or	a
	jr	z,chnk1			; az utols karaktert mindenkpp kirja
	inc	de
	cp	c
	jr	z,chnk0
chnk1:	dec	de
	or	a
	sbc	hl,de
	ld	c,l
	ld	b,h
	call	ed_bkout		; szveg kirsa
	ret

;
;	Karakteres sor s oszlop rtkbl vidememria-cm kiszmtsa
;	in:   A - sor szma (1..24)
;	      C - oszlop szma (0..63)
;	out:  A - memrialapozsi rtk
;	     DE - megrzdik
;	     HL - karakteres pozci bal fels bjtjnak cme a memriban
;
fk_vid:	dec	a			; sorszm 0..23 kz igaztva
	ld	h,a			; szmols: sorszm * 10 tv sor * 64 bjt/tv sor
	rlca				; A reg.= sorszm * 4
	rlca
	add	a,h			; A reg.= sorszm * 5
	ld	h,a
	ld	l,000h
	srl	h			; HL= sorszm * 5 * 128 = sorszm * 640
	rr	l
	ld	b,080h			; B = vidememria offszet (8000h) fels bjtja
	add	hl,bc			; vidememria offszet s kezd oszlopcm hozzadsa HL-hez
	ld	a,VID_PAGE_CFG		; A reg.= U0, U1, VID, CART
	ret

;
;	Legals sor trlse
;
fk_clsm:ld	a,IY_SUMLN		; als sor koordintja

;
;	Egy szveges sor trlse (csak a vidememriban)
;	in:  A - sor szma (1..24)
;	     C - kezd oszlop (0..63)   (fk_cln0 -nl belpve)
;	     D - kitlt bjt           (fk_cln0 -nl belpve)
;	     E - trlend hossz (1..64) (fk_cln0 -nl belpve)
;
fk_cln:	ld	c,000h			; C= kezd oszlop
	ld	e,040h			; E= trlend hossz
	ld	d,IY_CLRFILL
fk_cln0:call	fk_vid			; vide-cm szmtsa
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,d			; trl bjt A reg.-be
	ld	b,10			; a szveges sor 10 tv sorbl ll
	ld	c,e
	dec	c			; C= trlend hossz - 1
	jr	z,fk_cln4		; ugrs, ha a hossz csak 1
fk_cln1:push	bc
	ld	(hl),a			; sor els bjtjnak trlse
	ld	b,000h
	push	hl			; tv sor kezdetnek cme a verembe
	ld	d,h			; DE a kvetkez bjtra mutat
	ld	e,l
	inc	de
	ldir
	pop	hl
fk_cln2:ld	c,64
	add	hl,bc			; HL a kvetkez sor elejre mutat
	pop	bc
	djnz	fk_cln1			; ismtls mind a 10 tv sorra
fk_cln3:ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret
;
fk_cln4:ld	de,64
fk_cln5:ld	(hl),a			; els bjt trlse
	add	hl,de
	djnz	fk_cln5			; ismtls mind a 10 tv sorra
	jr	fk_cln3

;
;	Egy szveges sor inverz megjelentse
;	in:  A - sor szma (1..24)
;	     C - kezd oszlop (0..63) (fk_lin4 -nl belpve)
;	     D - az egy sorban lv invertland karakterek szma (fk_lin3, fk_lin4 -nl belpve)
;	     E - invertland kpsorok szma (fk_lin2, fk_lin3, fk_lin4 -nl belpve)
;
fk_linv:ld	e,10			; egy szveges sor 10 kppont magas
fk_lin2:ld	d,IY_INVFULL		; a teljes sor invertlsa
fk_lin3:ld	c,IY_INVSTART
fk_lin4:call	fk_vid			; vide-cm szmtsa
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,64			; a teljes sorhossz 64 karakter
	sub	d
	ld	c,a			; C= a sor vgn nem invertland bjtok
linv0:	ld	b,d			; az invertland sorhossz B-be
linv1:	ld	a,(hl)
	cpl				; 2-szn mdban egyszeren csak komplementlni kell
	ld	(hl),a			; a kpbjtot
	inc	hl
	djnz	linv1
	add	hl,bc			; HL a kvetkez sor elejre mutat
	dec	e
	jr	nz,linv0
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret

;
;	Kperny scroll-ozsa
;	in:  -
;	out: -
;
fk_scup:di
	ld	a,VID_PAGE_CFG		; A reg. = U0, U1, VID, CART
	out	(002h),a		; memrialapozs belltsa
	ld	d,IY_SCUP_H
	ld	e,IY_SCUP_L
	ld	hl,640
	add	hl,de
	ld	b,IY_SCSUM_H		; BC= msoland bjtok szma
	ld	c,IY_SCSUM_L
	ldir
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret
;
fk_scdw:di
	ld	a,VID_PAGE_CFG		; A reg. = U0, U1, VID, CART
	out	(002h),a		; memrialapozs belltsa
	ld	d,IY_SCDW_H
	ld	e,IY_SCDW_L
	ld	hl,-640
	add	hl,de
	ld	b,IY_SCSUM_H		; BC= msoland bjtok szma
	ld	c,IY_SCSUM_L
	lddr
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret

;
;	Egy oszlopfejlc kirsa
;	in:   C - sorkezdet eltolsa
;	     HL - a kirand oszlop adataira mutat
;	out: HL - a kvetkez oszlop adataira mutat
;
fk_hsr:	ld	a,c			; A reg.= sorkezdet eltolsa
	add	a,(hl)			; relatv oszlopkoordinta hozzadsa
	inc	hl
	ld	b,a
	ld	c,IY_HEADLN
	call	ed_cpos			; sugr-pozicionls karakteres pozciba
	ld	a,(sorttype)
	bit	7,a
	ld	c,05Eh			; '^' - nvekv sorrend jelzsre
	jr	z,fk_hs0
	ld	c,'v'			; 'v' - cskken sorrend jelzsre
fk_hs0:	and	07Fh
	cp	(hl)
	jr	z,fk_hs1
	ld	c,020h			; SPACE kirsa, ha nem az aktulis oszlop szerint van rendezve
fk_hs1:	call	ed_chout
	inc	hl
	ld	b,000h			; BC= kirand karakterek szma
	ld	c,(hl)
	inc	hl
	push	bc
	ld	de,strbuff		; szveg tmsolsa a string bufferbe
	ldir				; msols utn HL mr a kvetkez fejlc adataira mutat
	pop	bc
	ld	de,strbuff		; DE= szveg kezdcme
	call	ed_bkout		; fejlc-szveg kirsa
	ret
	
;
;	Oszlopfejlcek megjelentse (a vide funkcikat hasznlja)
;	in:  -
;	out: -
;
fk_head:ld	b,IY_NCLMS		; B= kirand oszlopok szma
	ld	c,IY_NAMECL		; C= sorkezdet eltolsa
	ld	hl,fk_fejtxt		; HL az els oszlop-szveg kezdcmre mutat
fk_hed1:push	bc
	call	fk_hsr			; fejlcek kirsa
	pop	bc
	djnz	fk_hed1
	ld	b,IY_PNUMCL		; B= panelsorszm X pozcija
	ld	c,IY_HEADLN		; C= fejlc sor Y
	call	ed_cpos			; sugr-pozicionls karakteres pozciba
	ld	c,'#'			; aktulis panelsorszm kirsa
	call	ed_chout
	xor	a
	ld	hl,pathbuff1
	ld	de,(path_ptr)
	sbc	hl,de			; ha az aktulis panel az #1-es akkor CY=0
	adc	a,'1'
	ld	c,a
	call	ed_chout
	ret

;
;	Oszlopfejlcek adatai
;	(X koordinta, rendezsi sorrend-azonost, szveg hossza, fejlc szvege)
;
fk_fejtxt:
	.db	COL_NEV, SORT_NEV, 003h
	.text	"N\221v"		; Nv
	.db	COL_KIT, SORT_KIT, 004h
	.text	"Kit."			; Kiterjeszts
	.db	COL_MERET, SORT_MERET, 005h
	.text	"M\221ret"		; Mret
	.db	COL_DATUM, SORT_DATUM, 005h
	.text	"D\220tum"		; Dtum
	.db	COL_ATTR, SORT_ATTR, 005h
	.text	"Attr."			; Attribtumok

;
kjltxt	.text	"Kijel\224lve: \000"	; Kijellve:
bajtxt	.text	" b\220jt / \000"	; bjt /
filtxt	.text	" f\220jlban\000"	; fjlban
sugtxt	.text	"S-S\226g\223\000"	; S-Sg

;
;
;	sszest sor megjelentse
;
fk_suml:ld	d,IY_INK
	ld	e,IY_PAPER
	call	ed_setcolors		; INK s PAPER belltsa
	ld	b,002h			; X poz.= 2
	ld	c,IY_SUMLN		; y poz.= als sor
	ld	a,(nselect)		; A reg.= kijellt fjlok szma
	or	a			; vannak kijellt fjlok?
;	jr	z,suml0			; ugrs, ha nem
	jr	suml0			; !!! kijelltek sszegzse tl lass, ezrt van kivve
	dec	b			; X poz.= 1
	ld	hl,kjltxt		; "Kijellve: "
	call	fk_prnt
	ld	a,(nselect)		; A reg.= kijellt fjlok szma
	ld	hl,selcap+3		; kijellt fjlok sszmretre mutat
	jr	suml1
suml0:	call	ed_cpos			; kurzor-pozicionls
	ld	a,(nfiles)		; A reg.= fjlok szma a knyvtrban (max. 99)
	ld	hl,dircap+3		; sszestett fjlmret a string-bufferbe
suml1:	push	af			; fjlok szma a verembe
	ld	de,strbuff
	call	fk_ascc
	ld	hl,bajtxt		; " bjt / "
	ld	bc,8
	ldir
	ld	a,020h			; bevezet SPACE karakterek levgsa s kirs a kpernyre
	call	fk_chnk
	pop	af			; A reg.= (kijellt) fjlok szma
	ld	l,a			; fjlok szma HL-be
	ld	h,000h
	ld	de,strbuff
	call	fk_dcon			; HL-ben adott 16 bites szm konvertlsa 4 jegy ASCII-ba
	ld	a,'0'			; bevezet '0' karakterek levgsa
	call	fk_chnk
	ld	hl,filtxt		; " fjlban"
	call	fk_prn0
	ld	hl,sugtxt		; "S-Sg"
	ld	bc,03700h		; X poz.= 55  y poz.= aktulis
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	bit	0,a
	call	z,fk_prnt		; szveg kirsa, ha 2-szn md
	ret

;
;	Egy knyvtrbejegyzs kirsa
;	in:   B - X poz. (ha 0 az X pozci az aktulis marad)
;	      C - Y poz. (ha 0 az Y pozci az aktulis marad)
;	     HL - nv 20 bjtos bejegyzsnek kezdete
;	out:    -
;
fk_fnir:push	bc			; koordintk mentse
	call	ed_cpos			; kurzor pozicionlsa
	call	fk_fnev			; formzott fjlnv elksztse
	pop	hl
	ld	h,a
	push	hl			; attribtum bjt s sorpozci mentse
	and	10h			; alknyvtr ?
	jr	z,fk_fni0		; ugrs, ha nem
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
fk_fni0:inc	a
	ld	d,a			; INK belltsa (2-szn mdban s fjloknl 1, 4-sznnl knyvtr esetn 2)
	ld	e,000h			; PAPER= 0
	call	ed_setcolors
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa: formzott fjlnv
	ld	de,00100h		; INK= 1 PAPER= 0
	call	ed_setcolors
	pop	hl
	bit	7,h
	ret	z			; visszatrs, ha nincs kivlasztva a fjl
	ld	a,l
	ld	c,IY_SELSTART
	ld	d,IY_SELCH		; D= az els 45 karakter a sorban
	ld	e,00Ah			; E= 10 TV sor
	call	fk_lin4			; sor inverz megjelentse
	ret

;
;	zenet kirsa a legals sorba
;	in:  HL - nullval lezrt string cme
;	out:    -
;
fk_ms0:	push	hl		
	call	fk_clsm			; als sor trlse
	pop	hl
	ld	d,IY_INK
	ld	e,IY_PAPER
	call	ed_setcolors		; INK s PAPER belltsa
	ld	b,001h			; X poz.= 1
	ld	c,IY_SUMLN		; y poz.= als sor
	ret
;
fk_msg:	call	fk_ms0
	jp	fk_prnt			; zenet kirsa a kperny aljra


;
;	zenet kirsa a legals sorba (fjlmanipulcis funkcikhoz)
;	in:  HL - nullval lezrt string cme az "sdc_util.asm" modulban
;	out:  L - aktulis grafikusmd (0-> 2 szn  1-> 4 szn)
;
fk_pmsg:call	fk_ms0			; zenetsor trlse, betszn belltsa
;
	CALL_UT_PRN0			; zenet kirsa a kperny aljra
;
	ld	l,IY_GRMODE		; grafikusmd L-be
	ret


;
;-----------------------------------------------------
;	Httr s kezdkperny megjelentse
;-----------------------------------------------------
;

;
;	tvonal s zenet sor trlse
;	in:  HL - a keret bal fels sarknak memriacme
;	out: -
;
fk_filn:ld	de,-(8000h)		; a vide memria kezdcmnek kivonsa a keret kezdcmbl
	add	hl,de
	ld	b,h			; az gy kiszmolt hossz rtk BC-be
	ld	c,l
	ld	hl,08000h		; HL a vidememria elejre mutat
	ld	de,08001h		; DE= HL + 1
	ld	a,IY_CLRFILL		; A reg.= kitlt bjt rtke
	ld	(hl),a
	ldir				; sorok kitltse az tvonal nv helyn
	ld	h,IY_SCDW_H		; HL= keret aljnak szmtsa a lefel scrollozs cmbl
	ld	l,IY_SCDW_L
	ld	de,513			; DE= (8 * 64) +1 (egy karakter sorban lv bjtok szma - 2 TV sor)
	add	hl,de
	ex	de,hl
	ld	hl,8000h + (240 * 64)	; HL= a karakteres kperny vge
	or	a
	sbc	hl,de			; kitltend memriaterlet szmtsa
	ld	b,h
	ld	c,l
	ld	h,d
	ld	l,e
	inc	de
	ld	(hl),a
	ldir				; sorok kitltse az zenet sor helyn
	ret

;
;	Ngyszgletes keret rajzolsa
;	in:   A - als s fels keret bitmintja ( 4-szn: 00Fh  2-szn: 0FFh)
;	      B - bal  oldali keret bitmintja   ( 4-szn: 008h  2-szn: 0C0h)
;	      C - jobb oldali keret bitmintja   ( 4-szn: 001h  2-szn: 003h)
;	     HL - a keret bal fels sarknak memriacme
;	out:  B - 00h
;
fk_bold:ld	d,b
	call	fk_bol2			; keret fels oldalnak rajzolsa
	push	af
	ld	a,d
	ld	b,IY_FRMLNS		; B  = sorok szma
	ld	de,63			; DE = kt oldal kztti tvolsg
fk_bol1:ld	(hl),a			; bal oldali keret
	add	hl,de
	ld	(hl),c			; jobb oldali keret
	inc	hl
	djnz	fk_bol1
	pop	af
fk_bol2:ld	b,64			; keret als oldala
fk_bol3:ld	(hl),a
	inc	hl
	djnz	fk_bol3
	ret

;
;	Sarokrszek rajzolsa
;	in:  DE - a keret adatbjtjaira mutat
;	     HL - bal fels kezdpozci
;	out: HL - a kirajzols utni sor bal szle
;	     DE - az utols adatbjt utnra mutat
;
fk_sark:ld	a,(de)
	inc	de
fk_sar0:ex	de,hl
	ldi
	ex	de,hl
	ld	bc,63
	add	hl,bc
	dec	a
	jr	nz,fk_sar0
	ret

;
;	Fejlc utols sornak sznezse 4-szn mdban (oszlopfejlc karakterei belernek)
;	in:  -
;	out: -
;
fk_fihl:ld	a,VID_PAGE_CFG		; A reg.= U0, U1, VID, U3
	di
	out	(002h),a		; memrialapozs belltsa
	ld	de,fv_fihlast		; DE a kitlt adatokra mutat
	ld	bc,-64			; BC = -64 (1 sornyi eltols)
	call	fk_fih0
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret


;
;	Fejlc sznezse 4-szn mdban
;	in:  -
;	out: -
;
fk_fihd:ld	de,fv_fihdat		; DE a kitlt adatokra mutat
	ld	bc,-768			; BC = -12 * 64 (12 sornyi eltols)
fk_fih0:ld	h,IY_SCUP_H		; HL = kperny scrollzs teteje
	ld	l,IY_SCUP_L
	add	hl,bc
	ld	c,IY_NAMECL		; C = fejlc kezd oszloppozcija
	ld	b,000h
	add	hl,bc
	add	hl,bc			; HL a fejlc bal fels sarkra mutat
	ld	a,IY_PNUMCL		; A reg.= fejlc vge -1 karakter
	inc	a
	sub	c
	add	a,a			; egy fejlc sorban lv bjtok = karakterek szma * 2
	ld	c,a			; fejlc sor bjtszma C-be
	dec	c			; -1 bjt, amit a sarokrajzols gyis fellrna
fk_fih1:ld	a,(de)
	inc	de
	or	a
	ret	z			; visszatrs, ha 0 a sorok szma (lezr nulla)
	ld	b,a
	ld	a,(de)
	inc	de
	push	de
fk_fih2:push	bc
	push	hl			; sor kezdete a verembe
	ld	d,h			; DE= HL + 1
	ld	e,l
	inc	de
	ld	(hl),a
	ld	b,000h			; BC= egy fejlc sor hossza
	ldir				; egy sor kitltse
	pop	hl
	ld	de,64			; DE= eltols a kvetkez sor elejhez
	add	hl,de
	pop	bc
	djnz	fk_fih2
	pop	de
	jp	fk_fih1

;
;	Fejlc-kitlt adatok (sorok szma, kitlt adat)
;
fv_fihdat
	.db	1, 00Fh
	.db	1, 0F0h
	.db	9, 0FFh
fv_fihlast
	.db	1, 0F0h
	.db	000h

;
;	Kppontadatok a keret sarkainak megrajzolshoz
;	formtum: hossz, adatbjt1, adatbjt2 ...
;
fv_bfker										; 4-szn mdban
	.db	004h,0F0h,0C3h,084h,084h						; keret  bal-fels sarknak lekerektse
	.db	00Ch,0F0h,0C3h,0B4h,0B5h,07Bh,07Bh,07Bh,07Bh,07Bh,073h,073h,070h 	; fejlc bal-fels sarknak lekerektse
	.db	00Ch,03Ch,0B4h,0B4h,0B4h,0B4h,0B4h,0B4h,0B4h,087h,080h,080h,080h	; fejlc jobb oldala

fv_bfker2										; 2-szn mdban
	.db	004h,000h,00Fh,030h,030h						; keret  bal-fels sarknak lekerektse
;	.db	009h,000h,00Fh,03Fh,03Fh,0FFh,0FFh,0FFh,0FFh,0FFh		 	; fejlc bal-fels sarknak lekerektse
	.db	009h,03Fh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh		 	; fejlc bal-fels sarknak lekerektse

;
fv_pnul	.db	000h,000h,000h,000h		; teljesen fekete paletta

fv_vmod0:

#ifndef SDC_VMOD1_ONLY
	.db	grmode0				; grafikus md -> 2 szn
	.db	pal0_0,pal1_0,pal2_0,pal3_0	; fekete, zld
	.db	head_ln2
	.db	fst_ln2
	.db	lst_ln2
	.db	sum_ln2
	.db	name_cl2
	.db	pnmu_cl2
	.db	nclms2
	.db	lst_ln2 - fst_ln2 + 1		; maximlisan kirhat sorok szma
	.dw	(lst_ln2 - fst_ln2) *640	; scroll-ozsnl msoland bjtok szma
	.dw	(fst_ln2 - 1)*640+8000h		; felfel scroll-ozs cl cme
	.dw	lst_ln2 * 640-1+8000h		; lefel  scroll-ozs cl cme
	.db	(lst_ln2 - fst_ln2 +2) * 10	; TV sorok szma a keretrajzolshoz
	.db	sel_start2
	.db	selch2
	.db	inv_start2
	.db	inv_full2
	.db	paper2
	.db	ink2
	.db	fill2
	.dw	fv_vmod1			; a kvetkez grafikus tblzat cme
#endif

fv_vmod1:
	.db	grmode				; grafikus md -> 4 szn
	.db	pal0,pal1,pal2,pal3		; sttkkeszld, fekete, fehr, sttvrs
	.db	head_ln
	.db	fst_ln
	.db	lst_ln
	.db	sum_ln
	.db	name_cl
	.db	pnmu_cl
	.db	nclms
	.db	lst_ln - fst_ln + 1		; maximlisan kirhat sorok szma
	.dw	(lst_ln - fst_ln) *640		; scroll-ozsnl msoland bjtok szma
	.dw	(fst_ln - 1)*640+8000h		; felfel scroll-ozs cl cme
	.dw	lst_ln*640-1+8000h		; lefel  scroll-ozs cl cme
	.db	(lst_ln - fst_ln +2) * 10	; TV sorok szma a keretrajzolshoz
	.db	sel_start			; kivlasztott sor invertlsi kezd oszlopa
	.db	selch				; kivlasztott sor invertlsi hossza bjtban
	.db	inv_start			; invertls kezd oszlopa
	.db	inv_full			; teljes sor invertls hossza bjtban
	.db	paper
	.db	ink
	.db	fill
	.dw	fv_vmod0			; a kvetkez grafikus tblzat cme


;
;	Palettaregiszterek belltsa
;	in:  -
;	out: -
;
fk_pal0:ld	hl,fv_pnul		; teljesen fekete paletta belltsa
	jr	fk_pal1
;
fk_pal:	push	iy			; az aktulis megjelentsi paletta belltsa
	pop	hl
	inc	hl			; a paletta adatok az IY+1 cmen vannak
fk_pal1:ld	b,004h			; B= belltand paletta-regiszterek szma (4)
	ld	c,05Fh			; C= paletta-regiszterek I/O cme -1
fk_pal2:inc	c			; regisztercm nvelse
	outi				; regiszter lltsa, B=B-1
	jr	nz,fk_pal2
	ret

;
;	Httr s keret rajzolsa, statikus szvegek kirsa
;	in:  -
;	out: -
;
fk_bord:ld	a,000h
	out	(000h),a
	call	fk_pal0			; teljesen fekete paletta belltsa
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
	ld	c,a			; videmd C-be
	push	af			; s a verembe is (ZF=0 -> 4-szn md)
	call	ed_vidmode		; videmd belltsa, kperny trlse
	call	fk_pal0			; teljesen fekete paletta belltsa ismt
	ld	a,VID_PAGE_CFG		; A reg.= U0, U1, VID, U3
	di
	out	(002h),a		; memrialapozs belltsa
	ld	h,IY_SCUP_H		; HL = a keretrajzols referenciapontja a felfel scrollozs clcmbl
	ld	l,IY_SCUP_L
	dec	h			; HL = HL - 4* 64 (4 sorral feljebb kezdi mint a scroll van)
	pop	af			; videmd visszatltse
	push	hl			; referenciapont a verembe is
	jr	nz,fk_bor0		; ugrs, ha 4-szn md
	ld	a,0FFh			; A reg. = keret als/fels vonalnak bitmintja
	ld	bc,0C003h		; B = bal, C = jobb oldali keret bitmintja
	call	fk_bold			; ngyszgletes keret rajzolsa
	pop	hl			; HL= keret bal fels sarknak cme
	ld	c,IY_NAMECL		; C = fejlc invertlsnak kezd oszloppozcija
	ld	d,b			; DE= oszloppozci 16 biten brzolva
	ld	e,c
	ld	a,IY_PNUMCL
	inc	a
	sub	c
	ld	b,a			; B= fejlc invertlsnak hossza
	push	bc			; fejlc invertlsnak hossza s kezdete a verembe
	add	hl,de
	push	hl			; a fejlc bal fels sarknak cme a verembe
fk_bor3:ld	(hl),d			; a fejlc terletre es keret-rsz letrlse
	inc	hl
	djnz	fk_bor3
	pop	hl
	push	hl
	or	a
	sbc	hl,de			; HL = keret bal fels sarknak memriacme
	ld	de,fv_bfker2		; DE = lekerekts kpbjtjainak cme
	call	fk_sark			; keret lekerektse
	pop	hl
	ld	bc,-385			; BC= -(6 * 64) -1 (eltolsi rtk a fejlc legfels sorhoz)
	add	hl,bc
	call	fk_sark			; fejlc lekerektse
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
;
	ld	bc,0101h		; pozici X=1 Y=1
	ld	hl,(path_ptr)
	call	fk_prnt			; tvonal kirsa
	call	fk_head			; oszlopfejlcek kirsa
	pop	bc			; fejlc invertlsnak hossza s kezdete a verembl
	ld	d,b			; D= fejlc invertlsnak hossza
	ld	e,009h			; csak 9 kpsor invertlsa, hogy ne rjen egybe a kivlaszt sorral
	ld	a,IY_HEADLN
	call	fk_lin4			; szveg invertlsa
	call	fk_pal			; paletta belltsa
	ret
;
fk_bor0:call	fk_filn			; tvonal s zenet sorok sznezse
	pop	hl			; HL= keret bal fels sarknak cme
	ld	a,00Fh			; A reg. = keret als/fels vonalnak bitmintja
	ld	bc,00801h		; B -> bal, C -> jobb oldali keret bitmintja
	call	fk_bold			; ngyszgletes keret rajzolsa
	call	fk_fihd			; fejlc sznezse
	ld	de,fv_bfker
	ld	h,IY_SCUP_H		; HL = keret kezdete a kperny scrollzsi tetejnl
	ld	l,IY_SCUP_L
	push	hl
	dec	h			; HL = HL - 4* 64 (4 sorral feljebb kezdi mint a scroll van)
	call	fk_sark			; keret lekerektse
	pop	hl
	ld	bc,-768			; BC = -12 * 64 (12 sornyi eltols)
	add	hl,bc
	push	hl
	ld	c,IY_NAMECL		; C = fejlc kezd oszloppozcija
	ld	b,000h
	add	hl,bc
	add	hl,bc			; HL a fejlc bal fels sarkra mutat
	dec	hl
	call	fk_sark			; fejlc lekerektse
	pop	hl
	ld	c,IY_PNUMCL		; C = fejlc vge - 1 karakter
	inc	c
	ld	b,000h
	add	hl,bc
	add	hl,bc			; HL a fejlc jobb fels sarkra mutat
	call	fk_sark			; fejlc jobb oldala
;
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	call	fk_pal			; paletta belltsa
	ld	d,IY_INK
	ld	e,IY_PAPER
	call	ed_setcolors		; INK s PAPER belltsa
	ld	hl,(path_ptr)		; az aktulis tvonal kirsa
	ld	bc,0100h		; max. 256 karakter tvizsglsa
	xor	a
	cpir				; tvonal-string vgnek megkeresse
	sub	c			; A reg.= sszes karakter a stringben lezr 0-val egytt
	cp	33
	jr	nc,fk_bor1		; ugrs, ha 31 karakternl hosszabb az tvonal
	ld	bc,0101h		; pozici X=1 Y=1
	ld	hl,(path_ptr)
	call	fk_prnt			; tvonal kirsa
	jp	fk_bor2
;
fk_bor1:ld	bc,26			; az tvonal utols 25 karakternek tmsolsa a stringbufferbe
	ld	de,strbuff+30
	dec	hl			; HL a lezr 0-ra mutat
	dec	hl			; HL az tvonal utols karakterre mutat
	lddr
	ld	a,'.'			; tvonalrvidts jelzse kt ponttal
	ld	(de),a
	dec	de
	ld	(de),a
	ld	bc,0003h		; az tvonal els 3 karakternek tmsolsa (meghajt betjele)
	ld	de,strbuff
	ld	hl,(path_ptr)
	ldir
	ld	bc,0101h		; pozici X=1 Y=1
	call	ed_cpos			; kurzor-pozcionls
	ld	bc,31			; 31 karakter a kirand szveg
	ld	de,strbuff
	call	ed_bkout		; szveg kirsa
fk_bor2:ld	de,00203h		; INK= 2  PAPER= 3
	call	ed_setcolors		; INK s PAPER belltsa
	call	fk_head			; oszlopfejlcek kirsa
	call	fk_fihl			; fejlc legals sornak visszasznezse
	ret


;
;-----------------------------------------------------
;	Szabad terlet-kirs kiegszt funkcii
;-----------------------------------------------------
;

;
;	Szabad terlet kirsa
;
fk_free:ld	hl,fr0text		; funkcinv kirsa a legals sorba
	call	fk_msg
	ld	hl,(path_ptr)
	ld	a,(hl)			; A reg.= aktulis tvonalnvbl a meghajt betjele
	or	a
	jr	nz,fk_fre0		; ugrs, ha nem 00h
	ld	a,(xaktbj)		; egybknt a meghajt lista aktulis ellemnek vizsglata
	call	fk_fadr			; aktulis bejegyzs cme HL-be
	ld	a,(hl)			; A reg.= a kurzor alatti meghajt betjele
fk_fre0:sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	b,a 
	ld	a,015h			; A = FISH funkci: lemez-foglaltsgi informcik beolvassa
	call	fk_fish			; FISH funkci hvsa
	ld	c,b
	ld	b,a			; visszaadja a hibakdot
	or	a
	jp	nz,fk_er4a		; ugrs, ha hiba trtnt
	push	bc			; C = szektorok szma alapegysgenknt
	push	de			; DE= alapegysgek szma
	push	hl			; HL= szabad alapegysgek szma
	ld	hl,fr1text		; bevezet szveg kirsa a legals sorba
	call	fk_msg
	pop	hl			; elmentett rtkek vissza
	pop	de
	pop	bc
;
	call	fk_frcp			; szabad terlet s teljes kapacits kirsa kB-ban a string bufferbe
;
	call	fk_prn2			; szveg kirsa a pufferbl a kpernyre
	xor	a			; hiba trlse
	push	af
	jp	fk_er5			; ugrs a befejezsre: gombnyoms, als sor helyrelltsa


fr0text	.text	"Meghajt\223 vizsg\220lata...\000"
fr1text	.text	"Szabad: \000"
fr2text	.text	" a "
fr3text	.text	" kB-b\223l"

;
;	Szabad terlet s teljes kapacits kirsa kB-ban a string bufferbe
;	in:   C - szektorok szma alapegysgenknt
;	     DE - alapegysgek szma
;	     HL - szabad alapegysgek szma
;	out: DE - a lezr nullra mutat a pufferben
;	     CY - CY=0
;
fk_frcp:push	de			; DE= alapegysgek szma
	push	bc			; C = szektorok szma alapegysgenknt
	ld	de,strbuff
	call	fk_frei			; szabad kapacits kirsa
	ld	bc,0003h
	ld	hl,fr3text
	ldir				; " kbjt"
	pop	bc
	pop	hl
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
	jr	nz,fk_frc0		; ugrs, ha nem 2-szn md
	push	hl
	ld	a,c
	ld	c,003h
	ld	hl,fr2text
	ldir				; " a "
	ld	c,a
	pop	hl
	call	fk_frei			; teljes kapacits kirsa
	ld	bc,0007h
	ld	hl,fr3text
	ldir				; " kbjt-bl"
fk_frc0:xor	a
	ld	(de),a			; lezr nulla elhelyezse
	ret

;
;	Klaszter-ben adott mret kiszmolsa kB-ban s kirsa a string bufferbe
;	in:   C - klaszterenknti szektorszm
;	     DE - kezd pozci a string bufferben
;	     HL - mret klaszterben
;	out: DE - az utols karakter utn mutat a pufferben
;
fk_frei:xor	a			; eredmny fels bitjei A reg.-ben lesznek
	jr	fk_fre2
;
fk_fre1:add	hl,hl			; HL (klaszterek szma) szorzsa a klaszterenknti szektorszmmal
	rla
fk_fre2:srl	c			; C jobbra lptetse 1-el (klaszterenknti szektorszm)
	jr	nz,fk_fre1		; ugrs, ha nem nulla
	srl	a
	rr	h			; A:HL osztsa 2-vel -> szabad terlet kbjtban
	rr	l
	ld	(numbuff_L),hl		; als 16 bit
	ld	hl,numbuff_H
	ld	(hl),a			; fels 16 bit
	inc	hl
	ld	(hl),000h
	push	de
	call	fk_ascc			; szm konvertlsa ASCII-ba
	pop	hl			; HL= szveg kezdete
	ld	c,020h			; bevezet SPACE karakterek levgsa
	xor	a
	ld	(de),a			; lezr nulla elhelyezse a konvertlt szm utn
	push	hl
fk_fre3:ld	a,(hl)			; karakterek vizsglata
	inc	hl
	cp	c
	jr	z,fk_fre3		; ismtls, amg SPACE
	dec	hl
	ex	de,hl			; DE az els nem SPACE karakterre mutat
	or	a
	sbc	hl,de
	ld	c,l			; BC= hasznos szveg hossza
	ld	b,h
	pop	hl
	ex	de,hl			; DE= szveg kezdete  HL= hasznos szmjegyek kezdete
	ret	z			; visszatrs, ha 0 lett a hossz
	ldir				; hasznos szveg elbbre msolsa
	ret

;
;-----------------------------------------------------
;	ASCII formtumra konvertl rutinok
;-----------------------------------------------------
;

;
;	BIN->BCD->ASCII konvertls
;
;	in: HL - 32 bites binris szm fels bjtjnak cme
;	    DE - ASCII szm els karakternek cme
;
fk_ascc:push	de			; ASCII szm puffer-cmnek mentse
	xor	a
	ld	de,bcdMSB
	ld	b,5			; B=BCD szm hossza bjtban (5=>10 szmjegy)
ascc0:	ld	(de),a			; BCD szm nullzsa
	inc	de
	djnz	ascc0
	ld	b,04			; binris szm hossza bjtban
	ld	c,08			; 8-szor lpteti balra HL ltal mutatott bjtot
ascc1:	push	bc
ascc2:	ld	de,bcdLSB		; DE=BCD szm als bjtja
	ld	b,5			; B=BCD szm hossza bjtban
	rlc	(hl)
ascc3:	ld	a,(de)
	adc	a,a
	daa
	ld	(de),a
	dec	de
	djnz	ascc3
	dec	c
	jr	nz,ascc2
	dec	hl
	pop	bc
	djnz	ascc1
	ld	de,bcdMSB		; BCD konvertlsa ASCII-ba, DE=BCD fels bjtja
	pop	hl			; HL=ASCII szm els karaktere
	ld	b,5			; B=BCD szm hossza bjtban
ascc4:	ld	a,(de)			; a kezd 0-k helyettestse SPACE-el
	and	0F0h
	jr	nz,ascc5
	ld	(hl),20h		; SPACE bersa
	inc	hl
	ld	a,(de)
	and	0Fh
	jr	nz,ascc6
	ld	(hl),20h		; SPACE bersa
	inc	hl
	inc	de
	djnz	ascc4
	dec	hl
	ld	(hl),30h		; ha a szm=0, akkor az utols bjtra '0' kerl
	inc	hl
	ex	de,hl
	ret
ascc5:	ld	a,(de)			; hasznos szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
ascc6:	ld	a,(de)
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
	inc	de
	djnz	ascc5
	ex	de,hl
	ret

;
;	Egybjtos BIN szm konvertlsa 2-szmjegy DEC ASCII-ba
;
;	in:  A - binris szm
;	    DE - hova
;
fk_bcon:ld	c,a			; C-bl lpnek ki a bitek
	xor	a			; A-ban lesz a kt helyirtk BCD szm
	ld	b,08			; 8-szor lpteti balra
bcon0:	rlc	c
	adc	a,a
	daa
	djnz	bcon0
bcon1:	ld	b,a			; BCD szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ld	a,b
	and	0Fh
	add	a,30h
	ld	(de),a
	inc	de
	ret

;
;	Ktbjtos BIN szm konvertlsa 4-szmjegy DEC ASCII-ba
;
;	in: HL - binris szm
;	    DE - hova
;
fk_dcon:push	de
	ld	de,0000h		; DE-ben lesz a 4-jegy BCD szm
	ld	b,08			; 8-szor lpteti balra H-t
dcon0:	rlc	h
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon0
	ld	b,08			; 8-szor lpteti balra L-t
dcon1:	rlc	l
	ld	a,e
	adc	a,a
	daa
	ld	e,a
	ld	a,d
	adc	a,a
	daa
	ld	d,a
	djnz	dcon1
	pop	hl			; BCD szmjegyek konvertlsa ASCII-ba
	ex	de,hl
	ld	a,h
	call	bcon1
	ld	a,l
	call	bcon1
	ret

;
;	BIN->dtum konvertls
;
;	in: HL - dtum cme
;	    DE - ASCII szm els karakternek cme
;
fk_date:ld	b,0			; v
	ld	c,(hl)
	srl	c
	push	hl
	ld	hl,1980
	add	hl,bc
	call	fk_dcon
	ld	a,'.'
	ld	(de),a
	inc	de
	pop	hl
	ld	a,(hl)			; hnap
	dec	hl
	rra
	ld	a,(hl)
	rra
	rra
	rra
	rra
	rra
	and	0Fh
	call	fk_bcon
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	a,(hl)			; nap
	and	1Fh
	call	fk_bcon
	ret

;
;	BIN->id konvertls
;
;	in: HL - id cme
;	    DE - ASCII szm els karakternek cme
;
fk_time:ld	a,(hl)			; ra
	rra
	rra
	rra
	and	1Fh
	call	fk_bcon
	ld	a,':'
	ld	(de),a
	inc	de
	ld	a,(hl)			; perc
	dec	hl
	ld	b,(hl)
	rl	b
	rla
	rl	b
	rla
	rl	b
	rla
	and	3Fh
	call	fk_bcon
	dec	hl
	ret

;
;	Angol kisbet nagybetv alaktsa
;	in:   A - ASCII karakterkd
;	out:  A - nagybetv alaktott karakter, ha A < 128
;	     CY - vltozatlan marad
;
fk_nagy:bit	7,a
	ret	nz
	bit	6,a
	ret	z
	res	5,a
	ret	
;
.end
